SystemOrganization addCategory: #'Epic-Library'!

WAFileLibrary subclass: #ERessources
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!ERessources methodsFor: 'as yet unclassified' stamp: 'RS 10/25/2010 20:38'!
layoutCss
	^ '
* { padding: 0px; margin: 0px; }

body {
	font-family: Verdana, Helvetica, Arial;
	font-size: 14px;
	background: #eeeeee;
}

a {
	color: #aa0000;
}

div, h1 {
	margin: 15px 30px;
}

body h1 {
	font-size: 17px;
	color: #333333;
	font-weight: normal;
	margin-bottom: 0px;
}

table.report {
	border: 1px solid #aa0000;
	background: #ffffff;
}

th {
	width: 150px;
	text-align: left;
}

tr.odd td {
	background: #ffdddd;
}

form {
	margin-left: 30px;
}

input.text {
	background: #ffffff;
	border: 1px solid #aa0000;
	padding: 5px;
	margin-right: 10px;
}

input.submit {
	background: #aa0000;
	color: #ffffff;
	padding: 3px;
	margin-right: 10px;
	border: 1px solid #550000;
}

label {
	color: #aa0000;
	font-size: 15px;
	font-weight: normal;
}

.buttons {
	margin-left: 155px;
}
'! !

Object subclass: #EAuthor
	instanceVariableNames: 'firstName lastName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!EAuthor methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:37'!
firstName
	"Answer the value of firstName"

	^ firstName! !

!EAuthor methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:37'!
firstName: anObject
	"Set the value of firstName"

	firstName := anObject! !

!EAuthor methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:37'!
lastName
	"Answer the value of lastName"

	^ lastName! !

!EAuthor methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:37'!
lastName: anObject
	"Set the value of lastName"

	lastName := anObject! !

Object subclass: #EBook
	instanceVariableNames: 'isbn title authors copies lendings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!EBook class methodsFor: 'as yet unclassified' stamp: 'sec 10/19/2010 17:24'!
descriptionCopies
	^ MANumberDescription new
		selectorAccessor: #copies;
		label: 'Number of copies';
		priority: 30;
		default: 1;
		beRequired;
		yourself! !

!EBook class methodsFor: 'as yet unclassified' stamp: 'sec 10/19/2010 17:19'!
descriptionISBN
	^ MAStringDescription new
		selectorAccessor: #isbn;
		label: 'ISBN';
		priority: 20;
		default: '';
		beRequired;
		yourself! !

!EBook class methodsFor: 'as yet unclassified' stamp: 'sec 10/19/2010 17:19'!
descriptionTitle
	^ MAStringDescription new
		selectorAccessor: #title;
		label: 'Title';
		priority: 10;
		default: '';
		beRequired;
		yourself! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/20/2010 16:40'!
addLending: aLending
	self lendings add: aLending.! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:36'!
authors
	"Answer the value of authors"

	^ authors! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:36'!
authors: anObject
	"Set the value of authors"

	authors := anObject! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 20:39'!
copies
	"Answer the value of copies"

	^ copies! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 20:39'!
copies: anObject
	"Set the value of copies"

	copies := anObject! !

!EBook methodsFor: 'initialize-release' stamp: 'RS 10/20/2010 17:04'!
descriptionLentCopies
	^ MANumberDescription new
		selectorAccessor: #lentCopies;
		label: 'Number of lent copies';
		priority: 40;
		default: 0;
		beReadonly;
		beRequired;
		yourself! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/20/2010 17:03'!
descriptionReport
	^ (self description 
		select: [:each | #(title isbn copies lentCopies) includes: each accessor selector ])
		add: self descriptionLentCopies;
		yourself.! !

!EBook methodsFor: 'initialize-release' stamp: 'RS 10/20/2010 16:19'!
initialize
	self 
		authors: OrderedCollection new;
		lendings: OrderedCollection new;
		copies: 1.
	! !

!EBook methodsFor: 'initialize-release' stamp: 'RS 10/20/2010 17:09'!
isAvailable
	^(self copies - self lentCopies) > 0! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:36'!
isbn
	"Answer the value of isbn"

	^ isbn! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:36'!
isbn: anObject
	"Set the value of isbn"

	isbn := anObject! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/20/2010 16:17'!
lendings
	"Answer the value of lendings"

	^ lendings! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/20/2010 16:17'!
lendings: anObject
	"Set the value of lendings"

	lendings := anObject! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/25/2010 19:24'!
lendingsNotReturned
	^self lendings select: [:each | each hasBeenReturned not ]! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/25/2010 19:24'!
lentCopies
	^self lendingsNotReturned size.! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:36'!
title
	"Answer the value of title"

	^ title! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:36'!
title: anObject
	"Set the value of title"

	title := anObject! !

Object subclass: #EImageDatabase
	instanceVariableNames: ''
	classVariableNames: 'Books'
	poolDictionaries: ''
	category: 'Epic-Library'!

!EImageDatabase class methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 20:20'!
books
	^ Books ifNil: [Books := OrderedCollection new]! !

Object subclass: #ELending
	instanceVariableNames: 'book startDate endDate person'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!ELending class methodsFor: 'as yet unclassified' stamp: 'RS 10/20/2010 16:05'!
descriptionPerson
	^ MAStringDescription new
		selectorAccessor: #person;
		label: 'Person';
		priority: 10;
		default: '';
		beRequired;
		yourself! !

!ELending class methodsFor: 'as yet unclassified' stamp: 'RS 10/25/2010 19:20'!
descriptionStartDate
	^ MADateDescription new
		selectorAccessor: #startDate;
		label: 'Start date';
		priority: 30;
		default: Date today;
		beRequired;
		yourself! !

!ELending class methodsFor: 'as yet unclassified' stamp: 'RS 10/20/2010 17:08'!
newWithBook: aBook
	|anObject|
	anObject  := self new.
	anObject book: aBook.
	aBook addLending: anObject.
	^ anObject.! !

!ELending methodsFor: 'accessing' stamp: 'RS 10/20/2010 16:02'!
book
	"Answer the value of book"

	^ book! !

!ELending methodsFor: 'accessing' stamp: 'RS 10/20/2010 16:15'!
book: anObject
	"Set the value of book"

	book := anObject! !

!ELending methodsFor: 'as yet unclassified' stamp: 'RS 10/25/2010 18:55'!
bookTitle
	^ self book title! !

!ELending methodsFor: 'as yet unclassified' stamp: 'RS 10/25/2010 18:55'!
descriptionReport
	^ (self description 
		select: [:each | #(person bookTitle startDate) includes: each accessor selector ])
		yourself.! !

!ELending methodsFor: 'accessing' stamp: 'RS 10/20/2010 16:02'!
endDate
	"Answer the value of endDate"

	^ endDate! !

!ELending methodsFor: 'accessing' stamp: 'RS 10/20/2010 16:02'!
endDate: anObject
	"Set the value of endDate"

	endDate := anObject! !

!ELending methodsFor: 'accessing' stamp: 'RS 10/20/2010 16:50'!
hasBeenReturned
	^self endDate notNil! !

!ELending methodsFor: 'accessing' stamp: 'RS 10/20/2010 16:02'!
person
	"Answer the value of person"

	^ person! !

!ELending methodsFor: 'accessing' stamp: 'RS 10/20/2010 16:02'!
person: anObject
	"Set the value of person"

	person := anObject! !

!ELending methodsFor: 'accessing' stamp: 'RS 10/20/2010 16:50'!
return
	self endDate: Date today.! !

!ELending methodsFor: 'accessing' stamp: 'RS 10/20/2010 16:02'!
startDate
	"Answer the value of startDate"

	^ startDate! !

!ELending methodsFor: 'accessing' stamp: 'RS 10/20/2010 16:02'!
startDate: anObject
	"Set the value of startDate"

	startDate := anObject! !

WAComponent subclass: #EBookComponent
	instanceVariableNames: 'books menuComponent listComponent report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!EBookComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 18:40'!
books
	"Answer the value of books"

	^ books! !

!EBookComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 18:40'!
books: anObject
	"Set the value of books"

	books := anObject! !

!EBookComponent methodsFor: 'rendering' stamp: 'sec 10/19/2010 15:03'!
children
	^Array with: self menuComponent with: self report.! !

!EBookComponent methodsFor: 'as yet unclassified' stamp: 'sec 10/19/2010 17:13'!
createBook
	|book|
	book := self call: EBook new asComponent addValidatedForm.
	book ifNotNil: [self books add: book. self refreshReport. ].! !

!EBookComponent methodsFor: 'as yet unclassified' stamp: 'sec 10/19/2010 17:13'!
deleteBook: aBook
	self books remove: aBook ifAbsent: [].
	self refreshReport.! !

!EBookComponent methodsFor: 'rendering' stamp: 'sec 10/19/2010 17:13'!
editBook: aBook
	self call: (aBook asComponent) addValidatedForm.
	self refreshReport.! !

!EBookComponent methodsFor: 'as yet unclassified' stamp: 'sec 10/19/2010 15:03'!
initialize
	super initialize.
	
	self books: EImageDatabase books.
	
	self initializeReport.
	self initializeMenuComponent.! !

!EBookComponent methodsFor: 'initialize-release' stamp: 'RS 10/18/2010 19:46'!
initializeMenuComponent
	self menuComponent: (EMenuComponent new
			addEntry: 'New book' withAction: [self createBook];
			addEntry: 'List books' withAction: [];
			 yourself)! !

!EBookComponent methodsFor: 'initialize-release' stamp: 'RS 10/20/2010 17:23'!
initializeReport
	self report: (MAReport
		rows: self books
		description: EBook new descriptionReport).
	self report
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #editBook: text: 'edit';
			yourself);
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #deleteBook: text: 'delete';
			yourself);
		addColumn: (MACommandColumn new
			filter: false; 
			propertyAt: #filterValue put: #isAvailable;
			addCommandOn: self selector: #lendBook: text: 'lend';
			yourself).! !

!EBookComponent methodsFor: 'rendering' stamp: 'RS 10/20/2010 17:08'!
lendBook: aBook
	aBook isAvailable ifTrue: [
		self call: (ELending newWithBook: aBook) asComponent addValidatedForm.
		self refreshReport.
		].! !

!EBookComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 19:43'!
menuComponent
	"Answer the value of menuComponent"

	^ menuComponent! !

!EBookComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 19:43'!
menuComponent: anObject
	"Set the value of menuComponent"

	menuComponent := anObject! !

!EBookComponent methodsFor: 'as yet unclassified' stamp: 'sec 10/19/2010 17:14'!
refreshReport
	self report rows: self books.! !

!EBookComponent methodsFor: 'rendering' stamp: 'RS 10/25/2010 18:46'!
renderContentOn: html 
	html heading: 'Books'.
	html div with: self menuComponent.
	html div with: self report.
! !

!EBookComponent methodsFor: 'accessing' stamp: 'sec 10/19/2010 14:46'!
report
	"Answer the value of report"

	^ report! !

!EBookComponent methodsFor: 'accessing' stamp: 'sec 10/19/2010 14:46'!
report: anObject
	"Set the value of report"

	report := anObject! !

!EBookComponent methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 18:55'!
testBooks
	^ OrderedCollection 
		with: (EBook new 
			isbn: '3551551677';
			title: 'Harry Potter und der Stein der Weisen')
		with: (EBook new 
			isbn: '3551551685';
			title: 'Harry Potter und die Kammer des Schreckens')! !

WAComponent subclass: #ELendingComponent
	instanceVariableNames: 'menuComponent report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!ELendingComponent methodsFor: 'as yet unclassified' stamp: 'RS 10/25/2010 19:11'!
initialize
	super initialize.
		
	self initializeReport.
	self initializeMenuComponent.! !

!ELendingComponent methodsFor: 'as yet unclassified' stamp: 'RS 10/25/2010 19:15'!
initializeMenuComponent
	self menuComponent: (EMenuComponent new
			addEntry: 'List Pending lendings' withAction: [];
			addEntry: 'List Past Lendings' withAction: [];
			 yourself)! !

!ELendingComponent methodsFor: 'as yet unclassified' stamp: 'RS 10/25/2010 19:23'!
initializeReport
	self report: (MAReport
		rows: self lendings
		description: ELending new descriptionReport).
	self report
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #returnBook: text: 'return';
			yourself).! !

!ELendingComponent methodsFor: 'accessing' stamp: 'RS 10/25/2010 19:25'!
lendings
	^((EImageDatabase books) inject: OrderedCollection new into:
		[ :aggregatedCollection :book | aggregatedCollection addAll: book lendingsNotReturned ] ).! !

!ELendingComponent methodsFor: 'accessing' stamp: 'RS 10/25/2010 18:50'!
menuComponent
	"Answer the value of menuComponent"

	^ menuComponent! !

!ELendingComponent methodsFor: 'accessing' stamp: 'RS 10/25/2010 18:50'!
menuComponent: anObject
	"Set the value of menuComponent"

	menuComponent := anObject! !

!ELendingComponent methodsFor: 'as yet unclassified' stamp: 'RS 10/25/2010 19:37'!
refreshReport
	self report rows: self lendings! !

!ELendingComponent methodsFor: 'as yet unclassified' stamp: 'RS 10/25/2010 19:13'!
renderContentOn: html 
	html heading: 'Lendings'.
	html div with: self menuComponent.
	html div with: self report.
! !

!ELendingComponent methodsFor: 'accessing' stamp: 'RS 10/25/2010 18:50'!
report
	"Answer the value of report"

	^ report! !

!ELendingComponent methodsFor: 'accessing' stamp: 'RS 10/25/2010 18:50'!
report: anObject
	"Set the value of report"

	report := anObject! !

!ELendingComponent methodsFor: 'as yet unclassified' stamp: 'RS 10/25/2010 19:37'!
returnBook: aLending
	aLending endDate: Date today.
	self refreshReport.! !

WAComponent subclass: #ELibrary
	instanceVariableNames: 'bookComponent lendingComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!ELibrary class methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 21:21'!
canBeRoot
	^ true! !

!ELibrary methodsFor: 'accessing' stamp: 'sec 10/18/2010 22:32'!
bookComponent
	"Answer the value of bookComponent"

	^ bookComponent! !

!ELibrary methodsFor: 'accessing' stamp: 'sec 10/18/2010 22:32'!
bookComponent: anObject
	"Set the value of bookComponent"

	bookComponent := anObject! !

!ELibrary methodsFor: 'accessing' stamp: 'RS 10/25/2010 19:12'!
children
	^Array with: self bookComponent with: self lendingComponent.! !

!ELibrary methodsFor: 'initialize-release' stamp: 'RS 10/25/2010 19:01'!
initialize
	super initialize.

	self bookComponent: EBookComponent new.
	self lendingComponent: ELendingComponent new.! !

!ELibrary methodsFor: 'accessing' stamp: 'RS 10/25/2010 18:59'!
lendingComponent
	"Answer the value of lendingComponent"

	^ lendingComponent! !

!ELibrary methodsFor: 'accessing' stamp: 'RS 10/25/2010 18:59'!
lendingComponent: anObject
	"Set the value of lendingComponent"

	lendingComponent := anObject! !

!ELibrary methodsFor: 'initialize-release' stamp: 'RS 10/25/2010 19:19'!
renderContentOn: html
	html 
		render: self bookComponent;
		render: self lendingComponent.! !

!ELibrary methodsFor: 'as yet unclassified' stamp: 'RS 10/25/2010 20:19'!
updateRoot: aRoot
	super updateRoot: aRoot.
	aRoot title: 'Epic Library'.
	aRoot link
		type: 'text/css';
		beStylesheet;
		addAll;
		url: ERessources / 'layout.css';
		yourself.
! !

WAComponent subclass: #EMenuComponent
	instanceVariableNames: 'entries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!EMenuComponent methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 19:38'!
addEntry: aString withAction: aBlock
	^ self entries add: aString -> aBlock! !

!EMenuComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 19:38'!
entries
	"Answer the value of entries"

	^ entries! !

!EMenuComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 19:38'!
entries: anObject
	"Set the value of entries"

	entries := anObject! !

!EMenuComponent methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 19:39'!
initialize
	super initialize.	
	self entries: OrderedCollection new! !

!EMenuComponent methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 19:37'!
renderContentOn: html 
	self entries
		do: [:entry | html anchor callback: entry value;
				 with: entry key]
		separatedBy: [html space]! !
